require "pred/version"

module Pred
  def self.letter_digit?(ch)
    return true if ('a'..'z').cover? ch
    return true if ('A'..'Z').cover? ch
    return true if ('0'..'9').cover? ch
    false
  end

  def self.letter?(ch)
    return true if ('a'..'z').cover? ch
    return true if ('A'..'Z').cover? ch
    false
  end
    
  def self.upper?(ch)
    ('A'..'Z').cover? ch
  end
  
  def self.lower?(ch)
    ('a'..'z').cover? ch
  end

  def self.digit?(ch)
    ('0'..'9').cover? ch
  end

  def self.count_digit?(ch)  # deprecate this ... not used anywhere
    ('0'..'9').cover? ch
  end
  
  def self.decrements?(str)
    str.each_char do |ch|
      return true if letter_digit? ch
    end
    return false
  end
  
  def self.decrementals?(str)
    last = str[-1]
    str = str[0..-2]
    mode = true
    if digit? last
      while !str.empty? do
        if mode
#          if last=='0'
#            if '1'==str[-1]  # we have the weird edge case
#              byebug
#              y = :not   # can't fix it here ... but stop and look around for fix
#            end
#          end
          return true if letter_digit?(str[-1])
          mode = false
        else
          if letter_digit?(str[-1])
            return digit? str[-1]
          end
        end
        str = str[0..-2]
      end
    elsif letter? last
      while !str.empty? do
        if mode
          return true if letter_digit?(str[-1])
          mode = false
        else
          if letter_digit?(str[-1])
            return letter? str[-1]
          end
        end
        str = str[0..-2]
      end
    else
      return decrementals?(str) unless str.empty?
    end
    return false
  end
  
  def self.lone_bottom?(str, fix=[])  # 'a'.pred  etc broken
    fix[0]=str.dup
    while !letter_digit?(str[-1])
      str = str[0..-2]
      return false if str.empty?
    end
    if "aA0".include? str[-1]
      unless decrements?(str[0..-2])
        fix[0][str.length-1] = dec(str[-1])
        return true
      end
    end
    return false
  end  
  
#  def self.inc(ch)
#    (ch.ord+1).chr(Encoding::UTF_8)
#  end
  
  def self.dec(ch)
    ii = (ch.ord-1)
    ii = 0 if ii < 0
    (ii).chr(Encoding::UTF_8)
  end
  
  def self.decrement_char(ch)
    if upper?(ch)
      t = dec(ch)
      return [:done, t] if upper?(t)
      return [:borrow, 'Z', t, :upper? ]
    elsif lower?(ch)
      t = dec(ch)
      return [:done, t] if lower?(t)
      return [:borrow, 'z', t, :lower? ]
    elsif digit?(ch)
      t = dec(ch)
      return [:done, t] if digit?(t)
      return [:borrow, '9', t, :digit? ]
    else
      t = dec(ch)
      return [:ignore, t]
    end
  end  
  
  def self.rcur_decrement_string(str, ref, pos)
    if pos < 0  # drop any pending stuff now even if borrow mode active
      return ref[:rtn].reverse
    end
    if ref[:mode] == :start
      rslt = decrement_char(str[pos])
      if rslt.first == :done
        ref[:rtn] += rslt[1]
        ref[:mode] = :done
        return rcur_decrement_string(str, ref, pos-1)
      elsif rslt.first == :borrow
        if decrementals? str[0..pos]
          ref[:mode] = :borrow
          ref[:rtn] += rslt[1]
        else  # drop one of the chars
          ref[:mode] = :done
        end
        return rcur_decrement_string(str, ref, pos-1)
      else
        if decrements? str[0..pos]
          ref[:rtn] += str[pos]
          ref[:mode] = :start
        else
          ref[:rtn] += rslt[1]
          ref[:mode] = :done
        end
        return rcur_decrement_string(str, ref, pos-1) 
      end
    elsif ref[:mode] == :done
      ref[:rtn] += str[pos]
      return rcur_decrement_string(str, ref, pos-1)
    elsif ref[:mode] == :borrow
      if letter_digit? str[pos]
        rslt = decrement_char(str[pos])
        if rslt.first == :done
#          if  (rslt[1]=='0')
#            byebug   # special edge case here ... nothing left to borrow if digit
#            y = :not
#          end          
          ref[:rtn] += rslt[1] unless (rslt[1]=='0')  # added this qualifier ...
          ref[:mode] = :done
          return rcur_decrement_string(str, ref, pos-1)
        elsif rslt.first == :borrow
          if decrementals? str[0..pos]
            ref[:mode] = :borrow
            ref[:rtn] += rslt[1]
          else  # drop one of the chars
            ref[:mode] = :done
          end
          return rcur_decrement_string(str, ref, pos-1)
        end
      else
        ref[:rtn] += str[pos]
      end 
      return rcur_decrement_string(str, ref, pos-1)   
    else
      ref[:rtn] += str[pos]
      return rcur_decrement_string(str, ref, pos-1)
    end
  end

  def self.decrement_string(str, ref={:mode=> :start, :rtn=> "" })
    return "" if str.empty?
    if str.length==1
      return "" if str.ord==0
    end
    return str[0..-2] + dec(str[-1]) unless decrements?(str)
    if lone_bottom?(str,rtn=[])
      return rtn.first      
    end
    return rcur_decrement_string(str, ref, str.length-1)     
  end
end

class String
  def pred
    Pred::decrement_string(self)
  end  
  def pred!
    replace pred
  end
end

class Symbol
  def pred
    Pred::decrement_string(self.to_s).to_sym
  end
end

class Integer  # move this to top
  def pred
    self - 1
  end
end










